<?php

namespace Drupal\twitter_api_test;

use GuzzleHttp\Client;
use GuzzleHttp\ClientInterface;
use GuzzleHttp\Handler\MockHandler;
use GuzzleHttp\HandlerStack;
use GuzzleHttp\Psr7\Response;

/**
 * A mock HTTP client factory.
 */
class MockHttpClientFactory {

  /**
   * Creates a mock HTTP client.
   *
   * @return \GuzzleHttp\ClientInterface
   *   The HTTP client.
   */
  public function createClient(): ClientInterface {
    $body = file_get_contents(__DIR__ . '/tweets.json');
    $mock = new MockHandler([
      new Response(200, ['Content-Type' => 'application/json'], $body),
    ]);
    $handlerStack = HandlerStack::create($mock);
    return new Client(['handler' => $handlerStack]);
  }

}
