<?php

namespace Drupal\Tests\twitter_api\Kernel;

use Drupal\KernelTests\KernelTestBase;

/**
 * Tests Twitter API client service.
 *
 * @group twitter_api
 */
class TwitterApiClientTest extends KernelTestBase {

  /**
   * {@inheritdoc}
   */
  protected static $modules = [
    'twitter_api',
    'twitter_api_test',
  ];

  /**
   * {@inheritdoc}
   */
  public function setUp(): void {
    parent::setUp();
    $this->installConfig('twitter_api_test');
  }

  /**
   * Tests we can get the client.
   */
  public function testClient() {
    $twitterClient = \Drupal::service('twitter_api.client');
    $this->assertNotNull($twitterClient);

    $tweets = $twitterClient->getTweets(['screen_name' => 'foo', 'count' => 1]);
    $this->assertNotEmpty($tweets);

    $tweet = $tweets[0];

    $this->assertEquals('850007368138018817', $tweet['id']);
    $this->assertEquals('twitterapi', $tweet['user']['screen_name']);
    $this->assertEquals('Twitter API', $tweet['user']['name']);
    $this->assertEquals('RT @TwitterDev: 1/ Today we’re sharing our vision for the future of the Twitter API platform!nhttps://t.co/XweGngmxlP', $tweet['text']);

    $this->assertNotEmpty($tweet['entities']['urls']);
    $url = $tweet['entities']['urls'][0];

    $this->assertEquals('https://t.co/XweGngmxlP', $url['url']);
    $this->assertEquals('https://cards.twitter.com/cards/18ce53wgo4h/3xo1c', $url['expanded_url']);
    $this->assertEquals('cards.twitter.com/cards/18ce53wg…', $url['display_url']);
  }

}
